<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>knexsetupguide</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="knex-setup-guide">Knex Setup Guide</h1>
<h2 id="create-your-project-directory">Create your project directory</h2>
<p>Create and initialize your a directory for your Express application.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1">$ <span class="fu">mkdir</span> node-knex-demo</a>
<a class="sourceLine" id="cb1-2" title="2">$ <span class="bu">cd</span> node-knex-demo</a>
<a class="sourceLine" id="cb1-3" title="3">$ <span class="ex">npm</span> init</a></code></pre></div>
<h2 id="knex">Knex</h2>
<p>Knex is a SQL query builder, mainly used for Node.js applications with built in model schema creation, table migrations, connection pooling and seeding.</p>
<h3 id="install-knex-and-knex-command-line-tool">Install Knex and Knex Command Line Tool</h3>
<p>Install <code>knex</code> <strong>globally</strong> on your local computer.</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1">$ <span class="ex">npm</span> install knex -g</a></code></pre></div>
<p>This will allow us to use <code>knex</code> as a command line tool that helps you create and manage your knex files.</p>
<p>In addition, you will need to also install the <code>knex</code> module <strong>locally</strong> to use in your project.</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1">$ <span class="ex">npm</span> install knex --save</a></code></pre></div>
<h2 id="configuring-your-database">Configuring your database</h2>
<p>For our example, we’re going to be connecting to a PostgreSQL database, we’ll need to install the <code>pg</code> module.</p>
<pre><code>$ npm install pg --save</code></pre>
<p>We can start by creating a <code>knexfile.js</code> in the root of your project which will act as our configuration for different environments, (e.g. – local development vs production).</p>
<pre><code>$ knex init</code></pre>
<p>This will create a <code>knexfile.js</code> with the different configurations for the different environments.</p>
<p><strong>Generated output <code>knexfile.js</code></strong>.</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="va">module</span>.<span class="at">exports</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="dt">development</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="dt">client</span><span class="op">:</span> <span class="st">&#39;sqlite3&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-4" title="4">    <span class="dt">connection</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-5" title="5">      <span class="dt">filename</span><span class="op">:</span> <span class="st">&#39;./dev.sqlite3&#39;</span></a>
<a class="sourceLine" id="cb6-6" title="6">    <span class="op">}</span></a>
<a class="sourceLine" id="cb6-7" title="7">  <span class="op">},</span></a>
<a class="sourceLine" id="cb6-8" title="8">  <span class="dt">staging</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-9" title="9">    <span class="dt">client</span><span class="op">:</span> <span class="st">&#39;postgresql&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-10" title="10">    <span class="dt">connection</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-11" title="11">      <span class="dt">database</span><span class="op">:</span> <span class="st">&#39;my_db&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-12" title="12">      <span class="dt">user</span><span class="op">:</span>     <span class="st">&#39;username&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-13" title="13">      <span class="dt">password</span><span class="op">:</span> <span class="st">&#39;password&#39;</span></a>
<a class="sourceLine" id="cb6-14" title="14">    <span class="op">},</span></a>
<a class="sourceLine" id="cb6-15" title="15">    <span class="dt">pool</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-16" title="16">      <span class="dt">min</span><span class="op">:</span> <span class="dv">2</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-17" title="17">      <span class="dt">max</span><span class="op">:</span> <span class="dv">10</span></a>
<a class="sourceLine" id="cb6-18" title="18">    <span class="op">},</span></a>
<a class="sourceLine" id="cb6-19" title="19">    <span class="dt">migrations</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-20" title="20">      <span class="dt">tableName</span><span class="op">:</span> <span class="st">&#39;knex_migrations&#39;</span></a>
<a class="sourceLine" id="cb6-21" title="21">    <span class="op">}</span></a>
<a class="sourceLine" id="cb6-22" title="22">  <span class="op">},</span></a>
<a class="sourceLine" id="cb6-23" title="23">  <span class="dt">production</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-24" title="24">    <span class="dt">client</span><span class="op">:</span> <span class="st">&#39;postgresql&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-25" title="25">    <span class="dt">connection</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-26" title="26">      <span class="dt">database</span><span class="op">:</span> <span class="st">&#39;my_db&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-27" title="27">      <span class="dt">user</span><span class="op">:</span>     <span class="st">&#39;username&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-28" title="28">      <span class="dt">password</span><span class="op">:</span> <span class="st">&#39;password&#39;</span></a>
<a class="sourceLine" id="cb6-29" title="29">    <span class="op">},</span></a>
<a class="sourceLine" id="cb6-30" title="30">    <span class="dt">pool</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-31" title="31">      <span class="dt">min</span><span class="op">:</span> <span class="dv">2</span><span class="op">,</span></a>
<a class="sourceLine" id="cb6-32" title="32">      <span class="dt">max</span><span class="op">:</span> <span class="dv">10</span></a>
<a class="sourceLine" id="cb6-33" title="33">    <span class="op">},</span></a>
<a class="sourceLine" id="cb6-34" title="34">    <span class="dt">migrations</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-35" title="35">      <span class="dt">tableName</span><span class="op">:</span> <span class="st">&#39;knex_migrations&#39;</span></a>
<a class="sourceLine" id="cb6-36" title="36">    <span class="op">}</span></a>
<a class="sourceLine" id="cb6-37" title="37">  <span class="op">}</span></a>
<a class="sourceLine" id="cb6-38" title="38"><span class="op">};</span></a></code></pre></div>
<p>Edit your <code>development</code> settings in <code>knexfile.js</code> to point to your postgres database, using your db username and password. DON’T FORGET TO CREATE YOUR DATABASE LOCALLY!</p>
<p><strong>Example <code>development</code> config object</strong></p>
<div class="sourceCode" id="cb7"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="dt">development</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-3" title="3">    <span class="dt">client</span><span class="op">:</span> <span class="st">&#39;pg&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-4" title="4">    <span class="dt">connection</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-5" title="5">      <span class="dt">host </span><span class="op">:</span> <span class="st">&#39;127.0.0.1&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-6" title="6">      <span class="dt">user </span><span class="op">:</span> <span class="st">&#39;[db_username]&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-7" title="7">      <span class="dt">password </span><span class="op">:</span> <span class="st">&#39;[db_password]&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-8" title="8">      <span class="dt">database </span><span class="op">:</span> <span class="st">&#39;[db_name]&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-9" title="9">      <span class="dt">charset</span><span class="op">:</span> <span class="st">&#39;utf8&#39;</span></a>
<a class="sourceLine" id="cb7-10" title="10">    <span class="op">},</span></a>
<a class="sourceLine" id="cb7-11" title="11">    <span class="dt">migrations</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-12" title="12">      <span class="dt">directory</span><span class="op">:</span> __dirname <span class="op">+</span> <span class="st">&#39;/knex/migrations&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb7-13" title="13">    <span class="op">},</span></a>
<a class="sourceLine" id="cb7-14" title="14">    <span class="dt">seeds</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-15" title="15">      <span class="dt">directory</span><span class="op">:</span> __dirname <span class="op">+</span> <span class="st">&#39;/knex/seeds&#39;</span></a>
<a class="sourceLine" id="cb7-16" title="16">    <span class="op">}</span></a>
<a class="sourceLine" id="cb7-17" title="17">  <span class="op">}</span></a>
<a class="sourceLine" id="cb7-18" title="18"><span class="op">}</span></a></code></pre></div>
<p>We want to create a <code>knex</code> directory at the root of our project to hold our <code>migrations</code> and <code>seeds</code> scripts. Inside of the <code>knex</code> directory, we need a <code>knex.js</code> file to hold the single instance of the <code>knex</code> module with the correct environment config.</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb8-1" title="1">$ <span class="fu">mkdir</span> knex</a>
<a class="sourceLine" id="cb8-2" title="2">$ <span class="fu">mkdir</span> knex/migrations</a>
<a class="sourceLine" id="cb8-3" title="3">$ <span class="fu">mkdir</span> knex/seeds</a>
<a class="sourceLine" id="cb8-4" title="4">$ <span class="fu">touch</span> knex/knex.js</a></code></pre></div>
<p>At this point, our project structure should look like this:</p>
<pre><code>.
├── knex
│   └── migrations
│   └── seeds
│   └── knex.js
└── knexfile.js
└── package.json</code></pre>
<p><em>For more information on migrations and seeds with knex, checkout the <strong><a href="https://gist.github.com/NigelEarle/70db130cc040cc2868555b29a0278261">knex migrations and seeds guide</a></strong>.</em></p>
<p><strong>Example <code>knex.js</code></strong></p>
<div class="sourceCode" id="cb10"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">const</span> environment <span class="op">=</span> <span class="va">process</span>.<span class="va">env</span>.<span class="at">ENVIRONMENT</span> <span class="op">||</span> <span class="st">&#39;development&#39;</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="kw">const</span> config <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;../knexfile.js&#39;</span>)[environment]<span class="op">;</span></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="va">module</span>.<span class="at">exports</span> <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;knex&#39;</span>)(config)<span class="op">;</span></a></code></pre></div>
<h2 id="create-your-express-application">Create your Express application</h2>
<pre><code>$ npm install express --save</code></pre>
<p>Now let’s create a <code>server.js</code> file in the root of your project. Create your express application how you normally would, for this example the server listening on port <code>3001</code>. Let’s also create a super basic <code>GET</code> endpoint to query our db.</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">const</span> express <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;express&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="kw">const</span> PORT <span class="op">=</span> <span class="va">process</span>.<span class="va">env</span>.<span class="at">PORT</span> <span class="op">||</span> <span class="dv">3001</span><span class="op">;</span></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="kw">const</span> knex <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;./knex/knex.js&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-4" title="4"><span class="kw">const</span> app <span class="op">=</span> <span class="at">express</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb12-5" title="5"></a>
<a class="sourceLine" id="cb12-6" title="6"><span class="va">app</span>.<span class="at">get</span>(<span class="st">&#39;/tasks&#39;</span><span class="op">,</span> (req<span class="op">,</span> res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb12-7" title="7">  <span class="co">// use the knex variable above to create dynamic queries</span></a>
<a class="sourceLine" id="cb12-8" title="8"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-9" title="9"></a>
<a class="sourceLine" id="cb12-10" title="10"><span class="va">app</span>.<span class="at">listen</span>(PORT<span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb12-11" title="11">  <span class="va">console</span>.<span class="at">log</span>(<span class="vs">`Listening on port: </span><span class="sc">${</span>PORT<span class="sc">}</span><span class="vs">`</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-12" title="12"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>Start the server:</p>
<pre><code>$ node server.js</code></pre>
</body>
</html>
